package de.accso.flexinale.data.services;

import de.accso.flexinale.data.model.Film;
import de.accso.flexinale.data.model.KinoSaal;
import de.accso.flexinale.data.model.Vorfuehrung;
import de.accso.flexinale.data.persistence.AbstractDao;
import de.accso.flexinale.data.persistence.KinoSaalDao;
import de.accso.flexinale.data.persistence.VorfuehrungDao;
import jakarta.transaction.Transactional;
import org.apache.poi.ss.usermodel.Row;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
@Transactional
public non-sealed class VorfuehrungUploadService extends AbstractExcelDataUploadService<Vorfuehrung> {
    private static final Logger LOGGER = LoggerFactory.getLogger(VorfuehrungUploadService.class);

    @Autowired
    private KinoSaalDao kinoSaalDao;

    @Autowired
    private VorfuehrungDao vorfuehrungDao;

    @Override
    public AbstractDao<Vorfuehrung> getDao() {
        return vorfuehrungDao;
    }

    @Override
    public String getNameOfExcelDataType() {
        return Vorfuehrung.class.getSimpleName();
    }

    @Override
    public Vorfuehrung createDataFromExcelRow(final Row excelRow) {
        String vorfuehrungId = excelRow.getCell(0).getStringCellValue();

        // expects date/time in format like for example 2023-02-20T17:45
        LocalDateTime zeit = LocalDateTime.parse(excelRow.getCell(1).getStringCellValue());

        Film film = new Film(excelRow.getCell(2).getStringCellValue());
        String kinoSaalId = excelRow.getCell(3).getStringCellValue();
        KinoSaal kinoSaal = kinoSaalDao.findById(kinoSaalId).orElseThrow(IllegalStateException::new);
        Vorfuehrung vorfuehrung = new Vorfuehrung(vorfuehrungId, zeit, film, kinoSaal);

        LOGGER.debug("New Vorfuehrung created: " + vorfuehrung);

        return vorfuehrung;
    }
}
